﻿B4A=true
Group=Default Group
ModulesStructureVersion=1
Type=StaticCode
Version=12.8
@EndOfDesignText@

Sub Process_Globals
	
	Dim N As Int ' Pontok száma
	Dim limits(6) As Float
	Dim circ_val(3) As Double 'x,y,rad
	
	Dim triangles(1,1) As Int
	Dim triangle_c As Int
	Dim points(1,1) As Double
	Dim lines(1,1) As Int 'p0,p1,repeat
	Dim lines_c As Int
	Dim fence(1,1) As Int
	Dim fence_length(1) As Int
	Dim fence_c As Int
	Dim lonely(1) As Boolean
	Dim lonely_c As Int
	Dim pi As Float =3.1415926541
	Dim arp(2) As Int
	Dim maxheightline As Float
	Dim worktime As Double 'return ms worktime
	Dim pointmax_limit As Int
	
End Sub


Sub initialise(pointmax As Int,fencemax As Int)
	pointmax_limit = pointmax
	Dim triangles(pointmax * 5, 4) As Int
		Dim triangle_c As Int
	Dim points(pointmax , 4) As Double
	Dim lines(pointmax * 4, 5) As Int 'p0,p1,repeat
	Dim lines_c As Int
	Dim fence(fencemax, pointmax ) As Int
	Dim fence_length(fencemax) As Int
	Dim fence_c As Int
	Dim lonely(pointmax ) As Boolean
	Dim lonely_c As Int
End Sub


Sub way (setmaxline As Float)
	
	worktime = DateTime.now
	
	triangle_c = 0
	lines_c = 0
	make_triangles (setmaxline / 100)
	find_fences
	find_lonely
	
	worktime = DateTime.now - worktime
	
End Sub



Sub find_lonely

	lonely_c = 0
	Dim find As Boolean
	For t = 0 To N - 1
		find = False
		For l = 0 To lines_c - 1
			If lines(l, 0) = t Or lines(l, 1) = t Then
				find = True
				Exit 
			End If
		Next 

		If find  Then
			lonely(t) = False
		Else
			lonely(t) = True
			lonely_c = lonely_c + 1
		End If
	Next



End Sub

Sub find_fences

	fence_c = 0
	
	For t = 0 To fence_length.Length-1:fence_length(t) = 0:Next
		
		Dim ch(200, 2) As Int
		Dim fp(N ) As Int
		Dim miny ,rang As Float
		Dim startp,aktp,last_line As Int
		Dim ch_c,kell,kovi As Int
		Dim minang,ang As Float
		

		'fence points    hany darab kerites-szakasz hasznalja a pontot--------------------------------------------------------------------------------------------------------------
		For t = 0 To N - 1: fp(t) = 0: Next
			For t = 0 To lines_c - 1
				If lines(t, 2) <> 1 Then Continue
				fp(lines(t, 0)) = fp(lines(t, 0)) + 1
				fp(lines(t, 1)) = fp(lines(t, 1)) + 1
			Next
			
			'Dim complete As Boolean
		
			Do While True 'Until complete


				'legalso pont megkereses
				miny = 99999999
				startp = -1
				For t = 0 To N - 1
					If points(t, 1) < miny And fp(t) > 0 Then
						startp = t
						miny = points(t, 1)
					End If
				Next
				If startp = -1 Then Exit 'Return 'THIS IS THE END

				'korbejaras ----------------------------------------------------------------------------------------------------------
				rang = pi * 2
				aktp = startp
				last_line = -1
	
	

				Do While  True 'startp = kovi

					If fence_length(fence_c)>pointmax_limit-5 Then Exit
					fence(fence_c, fence_length(fence_c)) = aktp
					fence_length(fence_c) = fence_length(fence_c) + 1

					'keresd meg azokat a pontokat, amik keritespontok, es aktp mellett van

					ch_c = 0
					For t = 0 To lines_c - 1
						If t = last_line Then Continue
						If lines(t, 2) <> 1 Then Continue
						kell = -1
						If lines(t, 0) = aktp Then kell = lines(t, 1)
						If lines(t, 1) = aktp Then kell = lines(t, 0)
						If kell = -1 Then Continue
						If fp(kell) = 0 Then Continue
						ch(ch_c, 0) = kell
						ch(ch_c, 1) = t
						ch_c = ch_c + 1
					Next

					minang = 999999
					kovi = -1
					For t = 0 To ch_c - 1
						ang = difang(rang, ATan2(points(ch(t, 0), 0) - points(aktp, 0), points(ch(t, 0), 1) - points(aktp, 1)))

						If ang < minang Then
							kovi = t
							minang = ang
						End If
					Next

					If kovi = -1 Then Return 'this is the end if erroring
					last_line = ch(kovi, 1)
					kovi = ch(kovi, 0)
					If startp = kovi Then  Exit 'complete = True '	Exit
					rang = ATan2(points(kovi, 0) - points(aktp, 0), points(kovi, 1) - points(aktp, 1))
					aktp = kovi
				Loop

				For t = 0 To fence_length(fence_c) - 1
					fp(fence(fence_c, t)) = fp(fence(fence_c, t)) - 2
				Next
			
				If fence_length(fence_c) > 2 Then
					If fence_c>fence.Length-2 Then Return
					fence_c = fence_c + 1
				End If
			Loop
		End Sub



Sub add_triangle (p0 As Int, p1 As Int, p2 As Int)
	triangles(triangle_c, 0) = p0
	triangles(triangle_c, 1) = p1
	triangles(triangle_c, 2) = p2
	add_line (p0, p1, triangle_c)
	add_line (p1, p2, triangle_c)
	add_line (p2, p0, triangle_c)
	triangle_c = triangle_c + 1
End Sub


Sub add_line (p0 As Int, p1 As Int, tri As Int)
	points(p0, 2) = points(p0, 2) + 1
	points(p1, 2) = points(p1, 2) + 1
	For t = 0 To lines_c - 1
		If (lines(t, 0) = p0 And lines(t, 1) = p1) Or (lines(t, 0) = p1 And lines(t, 1) = p0) Then
			lines(t, 2) = 2
			lines(lines_c, 4) = tri
			Return
		End If
	Next
	lines(lines_c, 0) = p0
	lines(lines_c, 1) = p1
	lines(lines_c, 2) = 1
	lines(lines_c, 3) = tri
	lines_c = lines_c + 1
End Sub

Sub add_points (x As Float, y As Float)
	If N = 0 Then
		Dim l As Float = 99999
		Dim limits(6) As Float = Array As Float (l,-l,0,l,-l,0)
	End If
	points(N, 0) = x
	points(N, 1) = y
	points(N, 2) = 0 'fence reg
	If points(N, 0) < limits(0) Then limits(0) = points(N, 0)
	If points(N, 0) > limits(1) Then limits(1) = points(N, 0)
	If points(N, 1) < limits(3) Then limits(3) = points(N, 1)
	If points(N, 1) > limits(4) Then limits(4) = points(N, 1)
	limits(2) = limits(1) - limits(0)
	limits(5) = limits(4) - limits(3)
	N = N + 1
End Sub



Sub IsDelaunay (t0 As Int, t1 As Int, t2 As Int) As Boolean
	CircumcenterAndRadius (points(t0, 0), points(t0, 1), points(t1, 0), points(t1, 1), points(t2, 0), points(t2, 1))
	If circ_val(2) = -1 Then Return False
	Dim tmp0,tmp1 As Float

	For m = 0 To N - 1 'is there a foreign point within the circumscribed circle?
		If m = t0 Or m = t1 Or m = t2 Then Continue
		tmp0 = points(m, 0) - circ_val(0)
		tmp1 = points(m, 1) - circ_val(1)
		If tmp0 * tmp0 + tmp1 * tmp1 < circ_val(2) Then Return False
	Next
	Return True
End Sub


Sub CircumcenterAndRadius (x1 As Double, y1 As Double, x2 As Double, y2 As Double, x3 As Double, y3 As Double) 'calculating the center and radius of a circumscribed circle
	Dim ftmp(3) As Double = Array As Double(y2-y3,y3-y1,y1-y2)
	Dim d As Double =  2 * (x1 * ftmp(0) + x2 * ftmp(1)+  x3 * ftmp(2))
	If Abs(d) <.00000001 Then 'colline out !
		circ_val(2) = -1
		Return
	End If
	Dim tmp0,tmp1,tmp2 As Double
	tmp0 = x1 * x1 + y1 * y1 '    ' triangle center (cx, cy)
	tmp1 = x2 * x2 + y2 * y2
	tmp2 = x3 * x3 + y3 * y3
	d = 1 / d
	circ_val(0) = (tmp0 * ftmp(0) + tmp1 * ftmp(1) + tmp2 * ftmp(2)) * d
	circ_val(1) = (tmp0 * (x3 - x2) + tmp1 * (x1 - x3) + tmp2 * (x2 - x1)) * d
	tmp0 = x1 - circ_val(0)
	tmp1 = y1 - circ_val(1)
	circ_val(2) = tmp0 * tmp0 + tmp1 * tmp1 'radius2
End Sub

Sub make_triangles (maxline As Float)

	maxheightline = limits(2) * maxline
	Dim tmp0 As Float = limits(5) * maxline
	If tmp0 > maxheightline Then maxheightline = tmp0
	maxheightline = maxheightline 
    
	For t0 = 0 To N - 3
		For t1 = t0 + 1 To N - 2
			If Abs(points(t0,0)-points(t1,0)) >maxheightline Then Continue
			If Abs(points(t0,1)-points(t1,1)) >maxheightline Then Continue
			For t2 = t1 + 1 To N - 1
				
				If Abs(points(t2,0)-points(t1,0)) >maxheightline Then Continue
				If Abs(points(t2,1)-points(t1,1)) >maxheightline Then Continue
				If Abs(points(t2,0)-points(t0,0)) >maxheightline Then Continue
				If Abs(points(t2,1)-points(t0,1)) >maxheightline Then Continue
     			If IsDelaunay(t0, t1, t2) Then add_triangle (t0, t1, t2)
			Next
		Next
	Next
End Sub

Sub  difang (angle1 As Float, angle2 As Float) As Float
	
    Dim diff As Float
    Dim c As Float =  2 * pi
    Do Until angle1 < c:        angle1 = angle1 - c:    Loop
    Do Until angle1 >= 0:        angle1 = angle1 + c:    Loop
    Do Until angle2 < c:        angle2 = angle2 - c:    Loop
    Do Until angle2 >= 0:        angle2 = angle2 + c:    Loop
    diff = angle1 - angle2
    If diff < -pi Then diff = diff + 2 * pi
    If diff > pi Then diff = diff - 2 * pi
    Return  diff
	
End Sub

Sub bitmapcreation (pwidth As Int, pheight As Int,show_triangles As Boolean) As Bitmap
	
	arp(0) = pwidth
	arp(1) = pheight
	Dim workbitmap As BitmapCreator
	workbitmap.Initialize(pwidth,pheight)
	Dim t2 As Float

	'draw lines -------------------------------------------------------------------------
	If show_triangles Then
		For t = 0 To lines_c-1
			workbitmap.DrawLine(arp_x(points(lines(t,0),0)),arp_y(points(lines(t,0),1)),arp_x(points(lines(t,1),0)),arp_y(points(lines(t,1),1)),Colors.argb(80,150,150,150),5)
		Next
	End If
	
	'draw frames -----------------------------------------------------------------------------------------------------------------
	Dim col As Int
	For af = 0 To fence_c-1
		col = Colors.ARGB(255,(40+342*af) Mod 127+127,(70+411*af) Mod 127+127,(80+111*af) Mod 127+127)
		For t = 0 To fence_length(af) - 1
			t2 = (t + 1) Mod fence_length(af)
			workbitmap.DrawLine(arp_x(points(fence(af,t),0)),arp_y(points(fence(af,t),1)),arp_x(points(fence(af,t2),0)),arp_y(points(fence(af,t2),1)),col,8)
		Next
	Next
	
	'draw points ----------------------------------------------------
	For t = 0 To N-1
		workbitmap.DrawCircle(arp_x(points(t,0)),arp_y(points(t,1)),6,Colors.argb(255,255,0,0),True,1)
	Next

	Return workbitmap.bitmap
End Sub

Sub arp_x(x As Float) As Int 'aspect ratio position X
	Return arp(0)/limits(2)*(x-limits(0))
End Sub

Sub arp_y(y As Float) As Int 'aspect ratio position Y
	Return arp(1)/limits(5)*(y-limits(3))
End Sub